    PROGRAM g05ldfe

!      G05LDF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : g05kbf, g05ldf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: n = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, igen
!      .. Local Arrays ..
       REAL (KIND=nag_wp)              :: x(n)
       INTEGER                         :: iseed(4)
!      .. Executable Statements ..
       WRITE (nout,*) 'G05LDF Example Program Results'
       WRITE (nout,*)
!      Initialize the seed to a repeatable sequence
       iseed(1) = 1762543
       iseed(2) = 9324783
       iseed(3) = 42344
       iseed(4) = 742355
!      IGEN identifies the stream.
       igen = 1
       CALL g05kbf(igen,iseed)

       ifail = 1
       CALL g05ldf(2,3,n,x,igen,iseed,ifail)

       IF (ifail==0) THEN

          WRITE (nout,99999) (x(i),i=1,n)

       ELSE
          WRITE (nout,99998) ifail
       END IF

99999  FORMAT (1X,F10.4)
99998  FORMAT (1X,' ** G05LDF returned with IFAIL = ',I5)
    END PROGRAM g05ldfe
