    Module nag_m_ib

!     NAG COPYRIGHT 2011.

!     .. Implicit None Statement ..
      Implicit None
!     .. Interface Blocks ..
      Interface
        Subroutine m01caf(rv,m1,m2,order,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
          Character (1), Intent (In) :: order
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rv(m2)
        End Subroutine m01caf
      End Interface
      Interface
        Subroutine m01cbf(iv,m1,m2,order,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
          Character (1), Intent (In) :: order
!         .. Array Arguments ..
          Integer, Intent (Inout) :: iv(m2)
        End Subroutine m01cbf
      End Interface
      Interface
        Subroutine m01ccf(ch,m1,m2,l1,l2,order,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: l1, l2, m1, m2
          Character (1), Intent (In) :: order
!         .. Array Arguments ..
          Character (*), Intent (Inout) :: ch(m2)
        End Subroutine m01ccf
      End Interface
      Interface
        Subroutine m01daf(rv,m1,m2,order,irank,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
          Character (1), Intent (In) :: order
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: rv(m2)
          Integer, Intent (Out) :: irank(m2)
        End Subroutine m01daf
      End Interface
      Interface
        Subroutine m01dbf(iv,m1,m2,order,irank,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
          Character (1), Intent (In) :: order
!         .. Array Arguments ..
          Integer, Intent (Out) :: irank(m2)
          Integer, Intent (In) :: iv(m2)
        End Subroutine m01dbf
      End Interface
      Interface
        Subroutine m01dcf(ch,m1,m2,l1,l2,order,irank,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: l1, l2, m1, m2
          Character (1), Intent (In) :: order
!         .. Array Arguments ..
          Integer, Intent (Out) :: irank(m2)
          Character (*), Intent (In) :: ch(m2)
        End Subroutine m01dcf
      End Interface
      Interface
        Subroutine m01def(rm,ldm,m1,m2,n1,n2,order,irank,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldm, m1, m2, n1, n2
          Character (1), Intent (In) :: order
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: rm(ldm,n2)
          Integer, Intent (Out) :: irank(m2)
        End Subroutine m01def
      End Interface
      Interface
        Subroutine m01dff(im,ldm,m1,m2,n1,n2,order,irank,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldm, m1, m2, n1, n2
          Character (1), Intent (In) :: order
!         .. Array Arguments ..
          Integer, Intent (In) :: im(ldm,n2)
          Integer, Intent (Out) :: irank(m2)
        End Subroutine m01dff
      End Interface
      Interface
        Subroutine m01djf(rm,ldm,m1,m2,n1,n2,order,irank,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldm, m1, m2, n1, n2
          Character (1), Intent (In) :: order
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: rm(ldm,n2)
          Integer, Intent (Out) :: irank(n2)
        End Subroutine m01djf
      End Interface
      Interface
        Subroutine m01dkf(im,ldm,m1,m2,n1,n2,order,irank,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldm, m1, m2, n1, n2
          Character (1), Intent (In) :: order
!         .. Array Arguments ..
          Integer, Intent (In) :: im(ldm,n2)
          Integer, Intent (Out) :: irank(n2)
        End Subroutine m01dkf
      End Interface
      Interface
        Subroutine m01dzf(compar,m1,m2,irank,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
!         .. Array Arguments ..
          Integer, Intent (Out) :: irank(m2)
!         .. Interface Blocks ..
          Interface
            Function compar(i,j)
!             .. Implicit None Statement ..
              Implicit None
!             .. Function Return Value ..
              Logical :: compar
!             .. Scalar Arguments ..
              Integer, Intent (In) :: i, j
            End Function compar
          End Interface
        End Subroutine m01dzf
      End Interface
      Interface
        Subroutine m01eaf(rv,m1,m2,irank,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: rv(m2)
          Integer, Intent (Inout) :: irank(m2)
        End Subroutine m01eaf
      End Interface
      Interface
        Subroutine m01ebf(iv,m1,m2,irank,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
!         .. Array Arguments ..
          Integer, Intent (Inout) :: irank(m2), iv(m2)
        End Subroutine m01ebf
      End Interface
      Interface
        Subroutine m01ecf(ch,m1,m2,irank,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
!         .. Array Arguments ..
          Integer, Intent (Inout) :: irank(m2)
          Character (*), Intent (Inout) :: ch(m2)
        End Subroutine m01ecf
      End Interface
      Interface
        Subroutine m01edf(cv,m1,m2,irank,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (Inout) :: cv(m2)
          Integer, Intent (Inout) :: irank(m2)
        End Subroutine m01edf
      End Interface
      Interface
        Function m01naf(valid,rv,m1,m2,item,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: m01naf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: item
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
          Logical, Intent (In) :: valid
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: rv(m2)
        End Function m01naf
      End Interface
      Interface
        Function m01nbf(valid,iv,m1,m2,item,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: m01nbf
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: item, m1, m2
          Logical, Intent (In) :: valid
!         .. Array Arguments ..
          Integer, Intent (In) :: iv(m2)
        End Function m01nbf
      End Interface
      Interface
        Function m01ncf(valid,ch,m1,m2,item,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: m01ncf
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
          Logical, Intent (In) :: valid
          Character (*), Intent (In) :: item
!         .. Array Arguments ..
          Character (*), Intent (In) :: ch(m2)
        End Function m01ncf
      End Interface
      Interface
        Subroutine m01zaf(iperm,m1,m2,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
!         .. Array Arguments ..
          Integer, Intent (Inout) :: iperm(m2)
        End Subroutine m01zaf
      End Interface
      Interface
        Subroutine m01zbf(iperm,m1,m2,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
!         .. Array Arguments ..
          Integer, Intent (Inout) :: iperm(m2)
        End Subroutine m01zbf
      End Interface
      Interface
        Subroutine m01zcf(iperm,m1,m2,icycl,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: m1, m2
!         .. Array Arguments ..
          Integer, Intent (Out) :: icycl(m2)
          Integer, Intent (Inout) :: iperm(m2)
        End Subroutine m01zcf
      End Interface
    End Module nag_m_ib
