    Module nag_x_ib

!     NAG COPYRIGHT 2011.

!     .. Use Statements ..
      Use nag_precisions, Only: wp
!     .. Implicit None Statement ..
      Implicit None
!     .. Interface Blocks ..
      Interface
        Function x01aaf(x)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: x01aaf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
        End Function x01aaf
      End Interface
      Interface
        Function x01abf(x)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: x01abf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
        End Function x01abf
      End Interface
      Interface
        Function x02ahf(x)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: x02ahf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
        End Function x02ahf
      End Interface
      Interface
        Function x02ajf()
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: x02ajf
        End Function x02ajf
      End Interface
      Interface
        Function x02akf()
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: x02akf
        End Function x02akf
      End Interface
      Interface
        Function x02alf()
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: x02alf
        End Function x02alf
      End Interface
      Interface
        Function x02amf()
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: x02amf
        End Function x02amf
      End Interface
      Interface
        Function x02anf()
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: x02anf
        End Function x02anf
      End Interface
      Interface
        Function x02bbf(x)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: x02bbf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
        End Function x02bbf
      End Interface
      Interface
        Function x02bef(x)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: x02bef
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
        End Function x02bef
      End Interface
      Interface
        Function x02bhf()
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: x02bhf
        End Function x02bhf
      End Interface
      Interface
        Function x02bjf()
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: x02bjf
        End Function x02bjf
      End Interface
      Interface
        Function x02bkf()
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: x02bkf
        End Function x02bkf
      End Interface
      Interface
        Function x02blf()
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: x02blf
        End Function x02blf
      End Interface
      Interface
        Function x02daf(x)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Logical :: x02daf
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: x
        End Function x02daf
      End Interface
      Interface
        Function x02djf()
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Logical :: x02djf
        End Function x02djf
      End Interface
      Interface
        Subroutine x03aaf(a,isizea,b,isizeb,n,istepa,istepb,c1,c2,d1,d2,sw, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: c1, c2
          Real (Kind=wp), Intent (Out) :: d1, d2
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: isizea, isizeb, istepa, istepb, n
          Logical, Intent (In) :: sw
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(isizea), b(isizeb)
        End Subroutine x03aaf
      End Interface
      Interface
        Subroutine x03abf(a,isizea,b,isizeb,n,istepa,istepb,cx,dx,sw,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Complex (Kind=wp), Intent (In) :: cx
          Complex (Kind=wp), Intent (Out) :: dx
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: isizea, isizeb, istepa, istepb, n
          Logical, Intent (In) :: sw
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(isizea), b(isizeb)
        End Subroutine x03abf
      End Interface
      Interface
        Subroutine x04aaf(iflag,nerr)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: iflag
          Integer, Intent (Inout) :: nerr
        End Subroutine x04aaf
      End Interface
      Interface
        Subroutine x04abf(iflag,nadv)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: iflag
          Integer, Intent (Inout) :: nadv
        End Subroutine x04abf
      End Interface
      Interface
        Subroutine x04acf(iounit,file,mode,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iounit, mode
          Character (*), Intent (In) :: file
        End Subroutine x04acf
      End Interface
      Interface
        Subroutine x04adf(iounit,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: iounit
        End Subroutine x04adf
      End Interface
      Interface
        Subroutine x04baf(nout,rec)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (In) :: nout
          Character (*), Intent (In) :: rec
        End Subroutine x04baf
      End Interface
      Interface
        Subroutine x04bbf(nin,recin,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: nin
          Character (*), Intent (Out) :: recin
        End Subroutine x04bbf
      End Interface
      Interface
        Subroutine x04caf(matrix,diag,m,n,a,lda,title,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, m, n
          Character (1), Intent (In) :: diag, matrix
          Character (*), Intent (In) :: title
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
        End Subroutine x04caf
      End Interface
      Interface
        Subroutine x04cbf(matrix,diag,m,n,a,lda,form,title,labrow,rlabs, &
            labcol,clabs,ncols,indent,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: indent, lda, m, n, ncols
          Character (1), Intent (In) :: diag, labcol, labrow, matrix
          Character (*), Intent (In) :: form, title
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Character (*), Intent (In) :: clabs(*), rlabs(*)
        End Subroutine x04cbf
      End Interface
      Interface
        Subroutine x04ccf(uplo,diag,n,a,title,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, uplo
          Character (*), Intent (In) :: title
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(*)
        End Subroutine x04ccf
      End Interface
      Interface
        Subroutine x04cdf(uplo,diag,n,a,form,title,labrow,rlabs,labcol,clabs, &
            ncols,indent,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: indent, n, ncols
          Character (1), Intent (In) :: diag, labcol, labrow, uplo
          Character (*), Intent (In) :: form, title
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(*)
          Character (*), Intent (In) :: clabs(*), rlabs(*)
        End Subroutine x04cdf
      End Interface
      Interface
        Subroutine x04cef(m,n,kl,ku,a,lda,title,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kl, ku, lda, m, n
          Character (*), Intent (In) :: title
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
        End Subroutine x04cef
      End Interface
      Interface
        Subroutine x04cff(m,n,kl,ku,a,lda,form,title,labrow,rlabs,labcol, &
            clabs,ncols,indent,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: indent, kl, ku, lda, m, n, ncols
          Character (*), Intent (In) :: form, title
          Character (1), Intent (In) :: labcol, labrow
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*)
          Character (*), Intent (In) :: clabs(*), rlabs(*)
        End Subroutine x04cff
      End Interface
      Interface
        Subroutine x04daf(matrix,diag,m,n,a,lda,title,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, m, n
          Character (1), Intent (In) :: diag, matrix
          Character (*), Intent (In) :: title
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
        End Subroutine x04daf
      End Interface
      Interface
        Subroutine x04dbf(matrix,diag,m,n,a,lda,usefrm,form,title,labrow, &
            rlabs,labcol,clabs,ncols,indent,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: indent, lda, m, n, ncols
          Character (1), Intent (In) :: diag, labcol, labrow, matrix, usefrm
          Character (*), Intent (In) :: form, title
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Character (*), Intent (In) :: clabs(*), rlabs(*)
        End Subroutine x04dbf
      End Interface
      Interface
        Subroutine x04dcf(uplo,diag,n,a,title,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n
          Character (1), Intent (In) :: diag, uplo
          Character (*), Intent (In) :: title
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(*)
        End Subroutine x04dcf
      End Interface
      Interface
        Subroutine x04ddf(uplo,diag,n,a,usefrm,form,title,labrow,rlabs,labcol, &
            clabs,ncols,indent,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: indent, n, ncols
          Character (1), Intent (In) :: diag, labcol, labrow, uplo, usefrm
          Character (*), Intent (In) :: form, title
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(*)
          Character (*), Intent (In) :: clabs(*), rlabs(*)
        End Subroutine x04ddf
      End Interface
      Interface
        Subroutine x04def(m,n,kl,ku,a,lda,title,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: kl, ku, lda, m, n
          Character (*), Intent (In) :: title
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
        End Subroutine x04def
      End Interface
      Interface
        Subroutine x04dff(m,n,kl,ku,a,lda,usefrm,form,title,labrow,rlabs, &
            labcol,clabs,ncols,indent,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: indent, kl, ku, lda, m, n, ncols
          Character (*), Intent (In) :: form, title
          Character (1), Intent (In) :: labcol, labrow, usefrm
!         .. Array Arguments ..
          Complex (Kind=wp), Intent (In) :: a(lda,*)
          Character (*), Intent (In) :: clabs(*), rlabs(*)
        End Subroutine x04dff
      End Interface
      Interface
        Subroutine x04eaf(matrix,diag,m,n,a,lda,title,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, m, n
          Character (1), Intent (In) :: diag, matrix
          Character (*), Intent (In) :: title
!         .. Array Arguments ..
          Integer, Intent (In) :: a(lda,*)
        End Subroutine x04eaf
      End Interface
      Interface
        Subroutine x04ebf(matrix,diag,m,n,a,lda,form,title,labrow,rlabs, &
            labcol,clabs,ncols,indent,ifail)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: indent, lda, m, n, ncols
          Character (1), Intent (In) :: diag, labcol, labrow, matrix
          Character (*), Intent (In) :: form, title
!         .. Array Arguments ..
          Integer, Intent (In) :: a(lda,*)
          Character (*), Intent (In) :: clabs(*), rlabs(*)
        End Subroutine x04ebf
      End Interface
      Interface
        Subroutine x05aaf(itime)
!         .. Implicit None Statement ..
          Implicit None
!         .. Array Arguments ..
          Integer, Intent (Out) :: itime(7)
        End Subroutine x05aaf
      End Interface
      Interface
        Function x05abf(itime)
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Character (30) :: x05abf
!         .. Array Arguments ..
          Integer, Intent (In) :: itime(7)
        End Function x05abf
      End Interface
      Interface
        Function x05acf(ctime1,ctime2)
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Integer :: x05acf
!         .. Scalar Arguments ..
          Character (*), Intent (In) :: ctime1, ctime2
        End Function x05acf
      End Interface
      Interface
        Subroutine x05adf(itimes,itimef,days,secs,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: secs
          Integer, Intent (Out) :: days
          Integer, Intent (Inout) :: ifail
!         .. Array Arguments ..
          Integer, Intent (In) :: itimef(7), itimes(7)
        End Subroutine x05adf
      End Interface
      Interface
        Subroutine x05aef(mode,itime,days,secs,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: secs
          Integer, Intent (Out) :: days
          Integer, Intent (Inout) :: ifail, mode
!         .. Array Arguments ..
          Integer, Intent (Inout) :: itime(7)
        End Subroutine x05aef
      End Interface
      Interface
        Function x05baf()
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Function Return Value ..
          Real (Kind=wp) :: x05baf
        End Function x05baf
      End Interface
      Interface
        Subroutine x05bef(mode,cputime,elapsed)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: cputime
          Real (Kind=wp), Intent (Out) :: elapsed
          Integer, Intent (Inout) :: mode
        End Subroutine x05bef
      End Interface
    End Module nag_x_ib
