    Module nag_h_ib

!     NAG COPYRIGHT 2011.

!     .. Implicit None Statement ..
      Implicit None
!     .. Interface Blocks ..
      Interface
        Subroutine h02bbf(itmax,msglvl,n,m,a,lda,bl,bu,intvar,cvec,maxnod, &
            intfst,maxdpt,toliv,tolfes,bigbnd,x,objmip,iwork,liwork,rwork, &
            lrwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: bigbnd, tolfes, toliv
          Real (Kind=wp), Intent (Out) :: objmip
          Integer, Intent (Inout) :: ifail, itmax
          Integer, Intent (In) :: intfst, lda, liwork, lrwork, m, maxdpt, &
            maxnod, msglvl, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+m), bu(n+m), cvec(n)
          Real (Kind=wp), Intent (Out) :: rwork(lrwork)
          Real (Kind=wp), Intent (Inout) :: x(n)
          Integer, Intent (In) :: intvar(n)
          Integer, Intent (Out) :: iwork(liwork)
        End Subroutine h02bbf
      End Interface
      Interface
        Subroutine h02bff(infile,maxn,maxm,optim,xbldef,xbudef,maxdpt,msglvl, &
            n,m,x,crname,iwork,liwork,rwork,lrwork,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xbldef, xbudef
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: infile, liwork, lrwork, maxdpt, maxm, maxn, &
            msglvl
          Integer, Intent (Out) :: m, n
          Character (3), Intent (In) :: optim
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: rwork(lrwork), x(maxn)
          Integer, Intent (Out) :: iwork(liwork)
          Character (8), Intent (Out) :: crname(maxn+maxm)
        End Subroutine h02bff
      End Interface
      Interface
        Subroutine h02buf(infile,maxn,maxm,optim,xbldef,xbudef,nmobj,nmrhs, &
            nmrng,nmbnd,mpslst,n,m,a,bl,bu,cvec,x,intvar,crname,nmprob,iwork, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: xbldef, xbudef
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: infile, maxm, maxn
          Integer, Intent (Out) :: m, n
          Logical, Intent (In) :: mpslst
          Character (8), Intent (Inout) :: nmbnd, nmobj, nmrhs, nmrng
          Character (8), Intent (Out) :: nmprob
          Character (3), Intent (In) :: optim
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: a(maxm,maxn), bl(maxn+maxm), &
            bu(maxn+maxm), cvec(maxn), x(maxn)
          Integer, Intent (Out) :: intvar(maxn), iwork(maxn+maxm)
          Character (8), Intent (Out) :: crname(maxn+maxm)
        End Subroutine h02buf
      End Interface
      Interface
        Subroutine h02bvf(n,m,a,lda,bl,bu,x,clamda,istate,crname,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), bl(n+m), bu(n+m), &
            clamda(n+m), x(n)
          Integer, Intent (In) :: istate(n+m)
          Character (8), Intent (In) :: crname(n+m)
        End Subroutine h02bvf
      End Interface
      Interface
        Subroutine h02bzf(n,m,bl,bu,clamda,istate,iwork,liwork,rwork,lrwork, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: liwork, lrwork, m, n
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Out) :: bl(n+m), bu(n+m), clamda(n+m)
          Real (Kind=wp), Intent (In) :: rwork(lrwork)
          Integer, Intent (Out) :: istate(n+m)
          Integer, Intent (In) :: iwork(liwork)
        End Subroutine h02bzf
      End Interface
      Interface
        Subroutine h02cbf(n,nclin,a,lda,bl,bu,cvec,h,ldh,qphess,intvar,lintvr, &
            mdepth,istate,xs,obj,ax,clamda,strtgy,iwrk,liwrk,wrk,lwrk,monit, &
            ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: lda, ldh, lintvr, liwrk, lwrk, mdepth, n, &
            nclin, strtgy
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: a(lda,*), cvec(*), h(ldh,*)
          Real (Kind=wp), Intent (Out) :: ax(max(1,nclin)), clamda(n+nclin), &
            wrk(lwrk)
          Real (Kind=wp), Intent (Inout) :: bl(n+nclin), bu(n+nclin), &
            xs(n+nclin)
          Integer, Intent (In) :: intvar(lintvr)
          Integer, Intent (Inout) :: istate(n+nclin)
          Integer, Intent (Out) :: iwrk(liwrk)
!         .. Interface Blocks ..
          Interface
            Subroutine qphess(n,jthcol,h,ldh,x,hx)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: jthcol, ldh, n
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: h(ldh,*), x(n)
              Real (Kind=wp), Intent (Out) :: hx(n)
            End Subroutine qphess
          End Interface
          Interface
            Subroutine monit(intfnd,nodes,depth,obj,x,bstval,bstsol,bl,bu,n, &
                halt,count)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Inout) :: bstval
              Real (Kind=wp), Intent (In) :: obj
              Integer, Intent (Inout) :: count
              Integer, Intent (In) :: depth, intfnd, n, nodes
              Logical, Intent (Inout) :: halt
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: bl(n), bstsol(n), bu(n), x(n)
            End Subroutine monit
          End Interface
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine h02cbf
      End Interface
      Interface
        Subroutine h02cbu(intfnd,nodes,depth,obj,x,bstval,bstsol,bl,bu,n,halt, &
            count)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: bstval
          Real (Kind=wp), Intent (In) :: obj
          Integer, Intent (Inout) :: count
          Integer, Intent (In) :: depth, intfnd, n, nodes
          Logical, Intent (Inout) :: halt
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: bl(n), bstsol(n), bu(n), x(n)
        End Subroutine h02cbu
      End Interface
      Interface
        Subroutine h02ccf(ioptns,inform)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
        End Subroutine h02ccf
      End Interface
      Interface
        Subroutine h02cdf(str)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Character (*), Intent (In) :: str
        End Subroutine h02cdf
      End Interface
      Interface
        Subroutine h02cef(n,m,nnz,iobj,ncolh,qphx,a,ha,ka,bl,bu,start,names, &
            nname,crname,ns,xs,intvar,lintvr,mdepth,istate,miniz,minz,obj, &
            clamda,strtgy,iz,leniz,z,lenz,monit,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: obj
          Integer, Intent (Inout) :: ifail, ns
          Integer, Intent (In) :: iobj, leniz, lenz, lintvr, m, mdepth, n, &
            ncolh, nname, nnz, strtgy
          Integer, Intent (Out) :: miniz, minz
          Character (1), Intent (In) :: start
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: a(nnz), bl(n+m), bu(n+m), xs(n+m)
          Real (Kind=wp), Intent (Out) :: clamda(n+m), z(lenz)
          Integer, Intent (In) :: ha(nnz), intvar(lintvr), ka(n+1)
          Integer, Intent (Inout) :: istate(n+m)
          Integer, Intent (Out) :: iz(leniz)
          Character (8), Intent (In) :: crname(nname), names(5)
!         .. Interface Blocks ..
          Interface
            Subroutine qphx(nstate,ncolh,x,hx)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: ncolh, nstate
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Out) :: hx(ncolh)
              Real (Kind=wp), Intent (In) :: x(ncolh)
            End Subroutine qphx
          End Interface
          Interface
            Subroutine monit(intfnd,nodes,depth,obj,x,bstval,bstsol,bl,bu,n, &
                halt,count)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Real (Kind=wp), Intent (Inout) :: bstval
              Real (Kind=wp), Intent (In) :: obj
              Integer, Intent (Inout) :: count
              Integer, Intent (In) :: depth, intfnd, n, nodes
              Logical, Intent (Inout) :: halt
!             .. Array Arguments ..
              Real (Kind=wp), Intent (In) :: bl(n), bstsol(n), bu(n), x(n)
            End Subroutine monit
          End Interface
        End Subroutine h02cef
      End Interface
      Interface
        Subroutine h02cey(intfnd,nodes,depth,obj,x,bstval,bstsol,bl,bu,n,halt, &
            count)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Inout) :: bstval
          Real (Kind=wp), Intent (In) :: obj
          Integer, Intent (Inout) :: count
          Integer, Intent (In) :: depth, intfnd, n, nodes
          Logical, Intent (Inout) :: halt
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: bl(n), bstsol(n), bu(n), x(n)
        End Subroutine h02cey
      End Interface
      Interface
        Subroutine h02cff(ioptns,inform)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Integer, Intent (Out) :: inform
          Integer, Intent (In) :: ioptns
        End Subroutine h02cff
      End Interface
      Interface
        Subroutine h02cgf(str)
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Character (*), Intent (In) :: str
        End Subroutine h02cgf
      End Interface
      Interface
        Subroutine h03abf(kost,ldkost,ma,mb,m,k15,maxit,k7,k9,numit,k6,k8,k11, &
            k12,z,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: z
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ldkost, m, ma, maxit, mb
          Integer, Intent (Out) :: numit
!         .. Array Arguments ..
          Integer, Intent (Out) :: k11(m), k12(m), k6(m), k7(m), k8(m), k9(m)
          Integer, Intent (Inout) :: k15(m)
          Integer, Intent (In) :: kost(ldkost,mb)
        End Subroutine h03abf
      End Interface
      Interface
        Subroutine h03adf(n,ns,ne,direct,nnz,d,irow,icol,splen,path,iwork, &
            work,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (Out) :: splen
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: n, ne, nnz, ns
          Logical, Intent (In) :: direct
!         .. Array Arguments ..
          Real (Kind=wp), Intent (In) :: d(nnz)
          Real (Kind=wp), Intent (Out) :: work(2*n)
          Integer, Intent (In) :: icol(nnz)
          Integer, Intent (Inout) :: irow(nnz)
          Integer, Intent (Out) :: iwork(3*n+1), path(n)
        End Subroutine h03adf
      End Interface
      Interface
        Subroutine h05aaf(irevcm,mincr,m,ip,nbest,drop,lz,z,la,a,bscore,bz, &
            mincnt,gamma,icomm,licomm,rcomm,lrcomm,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: gamma
          Integer, Intent (Inout) :: drop, ifail, irevcm, la, lz
          Integer, Intent (In) :: ip, licomm, lrcomm, m, mincnt, mincr, nbest
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: bscore(max(nbest,m)), &
            rcomm(lrcomm)
          Integer, Intent (Inout) :: a(max(nbest,m)), bz(m-ip,nbest), &
            icomm(licomm), z(m-ip)
!         .. Intrinsic Procedures ..
          Intrinsic :: max
        End Subroutine h05aaf
      End Interface
      Interface
        Subroutine h05abf(mincr,m,ip,nbest,la,bscore,bz,f,mincnt,gamma,iuser, &
            ruser,ifail)
!         .. Use Statements ..
          Use nag_precisions, Only: wp
!         .. Implicit None Statement ..
          Implicit None
!         .. Scalar Arguments ..
          Real (Kind=wp), Intent (In) :: gamma
          Integer, Intent (Inout) :: ifail
          Integer, Intent (In) :: ip, m, mincnt, mincr, nbest
          Integer, Intent (Out) :: la
!         .. Array Arguments ..
          Real (Kind=wp), Intent (Inout) :: bscore(nbest), ruser(*)
          Integer, Intent (Inout) :: bz(m-ip,nbest), iuser(*)
!         .. Interface Blocks ..
          Interface
            Subroutine f(m,drop,lz,z,la,a,score,iuser,ruser,info)
!             .. Use Statements ..
              Use nag_precisions, Only: wp
!             .. Implicit None Statement ..
              Implicit None
!             .. Scalar Arguments ..
              Integer, Intent (In) :: drop, la, lz, m
              Integer, Intent (Inout) :: info
!             .. Array Arguments ..
              Real (Kind=wp), Intent (Inout) :: ruser(*)
              Real (Kind=wp), Intent (Out) :: score(max(la,1))
              Integer, Intent (In) :: a(la), z(lz)
              Integer, Intent (Inout) :: iuser(*)
!             .. Intrinsic Procedures ..
              Intrinsic :: max
            End Subroutine f
          End Interface
        End Subroutine h05abf
      End Interface
    End Module nag_h_ib
